/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of MonotoneChain.xs. Do not edit this file, edit MonotoneChain.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "MonotoneChain.xs"
#define PERL_NO_GET_CONTEXT     /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

typedef struct {
  double x;
  double y;
} point_t;

typedef point_t* point_ptr_t;

/* Three points are a counter-clockwise turn if ccw > 0, clockwise if
 * ccw < 0, and collinear if ccw = 0 because ccw is a determinant that
 * gives the signed area of the triangle formed by p1, p2 and p3.
 */
STATIC double
ccw(point_t* p1, point_t* p2, point_t* p3)
{
  return (p2->x - p1->x)*(p3->y - p1->y) - (p2->y - p1->y)*(p3->x - p1->x);
}

/* Returns a list of points on the convex hull in counter-clockwise order.
 * Note: the last point in the returned list is the same as the first one.
 */
STATIC void
convex_hull(point_t* points, SSize_t npoints, point_ptr_t** out_hull, SSize_t* out_hullsize)
{
  point_ptr_t* hull;
  SSize_t i, t, k = 0;

  hull = *out_hull;

  /* lower hull */
  for (i = 0; i < npoints; ++i) {
    while (k >= 2 && ccw(hull[k-2], hull[k-1], &points[i]) <= 0) --k;
    hull[k++] = &points[i];
  }

  /* upper hull */
  for (i = npoints-2, t = k+1; i >= 0; --i) {
    while (k >= t && ccw(hull[k-2], hull[k-1], &points[i]) <= 0) --k;
    hull[k++] = &points[i];
  }

  *out_hull = hull;
  *out_hullsize = k;
}

#line 62 "MonotoneChain.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 114 "MonotoneChain.c"

XS(XS_Math__ConvexHull__MonotoneChain_convex_hull_sorted); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__ConvexHull__MonotoneChain_convex_hull_sorted)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "points");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	AV*	points;
#line 59 "MonotoneChain.xs"
    AV* hull_points;
    SSize_t out_hullsize, npoints, arylen, i;
    point_t* cpoints;
    point_ptr_t* out_hull;
    AV* inner_av;
    AV* out_av;
    SV** elemptr;
    SV* elem;
#line 139 "MonotoneChain.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    points = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Math::ConvexHull::MonotoneChain::convex_hull_sorted",
				"points");
		}
	} STMT_END;
#line 68 "MonotoneChain.xs"
    npoints = av_len(points)+1;
    if (npoints <= 2) {
      out_av = newAV();
      av_fill(out_av, npoints-1);
      for (i = 0; i < npoints; ++i) {
        elemptr = av_fetch(points, i, 0);
        av_store(out_av, i, newSVsv(*elemptr));
      }
      XPUSHs(sv_2mortal(newRV_noinc((SV*)out_av)));
      XSRETURN(1);
    }
    else {
      cpoints = (point_t*)malloc(npoints * sizeof(point_t));
      for (i = 0; i < npoints; ++i) {
        if (NULL == (elemptr = av_fetch(points, i, 0))) {
          free(cpoints);
          croak("Could not fetch element from array");
        }

        elem = *elemptr;
        if (SvROK(elem) && SvTYPE(SvRV(elem)) == SVt_PVAV) {
          inner_av = (AV*)SvRV(elem);
          arylen = av_len(inner_av)+1;
          if (arylen < 2) {
            free(cpoints);
            croak("Input array does not only contain point-like structures with at least two coordinates? At point %i.", i);
          }
          else if (NULL == (elemptr = av_fetch(inner_av, 0, 0))) {
            free(cpoints);
            croak("Could not fetch element from array");
          }
          cpoints[i].x = SvNV(*elemptr);

          if (NULL == (elemptr = av_fetch(inner_av, 1, 0))) {
            free(cpoints);
            croak("Could not fetch element from array");
          }
          cpoints[i].y = SvNV(*elemptr);

        }
        else {
          free(cpoints);
          croak("Input array does not only contain point-like structures?");
        }
      }
    } /* end for i in 0..npoints */

    out_hull = malloc(npoints*2 * sizeof(point_ptr_t));
    convex_hull(cpoints, npoints, &out_hull, &out_hullsize);
    out_av = newAV();
    av_fill(out_av, out_hullsize-2);
    for (i = 0; i < out_hullsize-1; ++i) {
      inner_av = newAV();
      av_fill(inner_av, 1);
      av_store(inner_av, 0, newSVnv(out_hull[i]->x));
      av_store(inner_av, 1, newSVnv(out_hull[i]->y));
      elem = newRV_noinc((SV*)inner_av);
      av_store(out_av, i, elem);
    }
    free(out_hull);
    free(cpoints);
    XPUSHs(sv_2mortal(newRV_noinc((SV*)out_av)));
    XSRETURN(1);
#line 217 "MonotoneChain.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Math__ConvexHull__MonotoneChain); /* prototype to pass -Wmissing-prototypes */
XS(boot_Math__ConvexHull__MonotoneChain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        newXS("Math::ConvexHull::MonotoneChain::convex_hull_sorted", XS_Math__ConvexHull__MonotoneChain_convex_hull_sorted, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

